local f = CreateFrame("Frame")

local defaults = {
    hideRealm = true,
	hideName = false,
    hideRole = false,
}

function f:OnEvent(event, addOnName)
	if addOnName == "HideRealmNames" then
		HideRealmNamesDB = HideRealmNamesDB or CopyTable(defaults)
		self.db = HideRealmNamesDB
		self:InitializeOptions()
        if self.db.hideRealm then
            --party style frames
            hooksecurefunc("UnitFrame_Update",function(frame)
	            if frame and not frame:IsForbidden() then
		        local frame_name = frame:GetName()
		        if frame_name and frame_name:match("^PartyMemberFrame%d") or ("^CompactPartyMemberFrame%d") and frame.unit and frame.name then
			    local unit_name = GetUnitName(frame.unit,true)
			    if unit_name then
				frame.name:SetText(unit_name:match("[^-]+"))
			end
		end
	end
end)
            --raid style frames
            hooksecurefunc("CompactUnitFrame_UpdateName",function(frame)
	            if frame and not frame:IsForbidden() then
		        local frame_name = frame:GetName()
		        if frame_name and frame_name:match("^CompactRaidFrame%d") or ("^CompactRaidGroup%dMember%d") or ("^CompactPartyFrameMember%d") and frame.unit and frame.name then
			    local unit_name = GetUnitName(frame.unit,true)
			    if unit_name then
				frame.name:SetText(unit_name:match("[^-]+"))
			end
		end
	end
end)
        end
			if self.db.hideName then
				DefaultCompactUnitFrameOptions.displayName = false
                end
            if self.db.hideRole then
				DefaultCompactUnitFrameOptions.displayRoleIcon = false
			end
		end
end

f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", f.OnEvent)

function f:InitializeOptions()
	self.panel = CreateFrame("Frame")
	self.panel.name = "Hide Realm Names"
    
    local cb_hide_realms = CreateFrame("CheckButton", nil, self.panel, "InterfaceOptionsCheckButtonTemplate")
	cb_hide_realms:SetPoint("TOPLEFT", 20, -20)
	cb_hide_realms.Text:SetText("Hide Realms (requires reload)")
	cb_hide_realms:HookScript("OnClick", function(_, btn, down)
		self.db.hideRealm = cb_hide_realms:GetChecked()
	end)
	cb_hide_realms:SetChecked(self.db.hideRealm)

	local cb_hide_names = CreateFrame("CheckButton", nil, self.panel, "InterfaceOptionsCheckButtonTemplate")
	cb_hide_names:SetPoint("TOPLEFT", cb_hide_realms, 0, -30)
	cb_hide_names.Text:SetText("Hide Player Names (requires reload)")
	cb_hide_names:HookScript("OnClick", function(_, btn, down)
		self.db.hideName = cb_hide_names:GetChecked()
	end)
	cb_hide_names:SetChecked(self.db.hideName)

    local cb_hide_roles = CreateFrame("CheckButton", nil, self.panel, "InterfaceOptionsCheckButtonTemplate")
	cb_hide_roles:SetPoint("TOPLEFT", cb_hide_names, 0, -30)
	cb_hide_roles.Text:SetText("Hide Role Icons (requires reload)")
	cb_hide_roles:HookScript("OnClick", function(_, btn, down)
		self.db.hideRole = cb_hide_roles:GetChecked()
	end)
	cb_hide_roles:SetChecked(self.db.hideRole)

	local btn = CreateFrame("Button", nil, self.panel, "UIPanelButtonTemplate")
	btn:SetPoint("TOPLEFT", cb_hide_roles, 0, -40)
	btn:SetText("Save and Reload")
	btn:SetWidth(126)
	btn:SetScript("OnClick", function()
        ReloadUI();
	end)

	InterfaceOptions_AddCategory(self.panel)
end

SLASH_HRN1 = "/hrn"
SLASH_HRN2 = "/hiderealmnames"

SlashCmdList.HRN = function(msg, editBox)
	InterfaceOptionsFrame_OpenToCategory(f.panel)
end